<template>
    <div>
        <div class="alert alert-success" role="alert" v-if="orderPosted">
            Your order has been received. The delivery information will be notified through your email and phone.
            <router-link to="/shop"><a>Shop More</a></router-link>
        </div>

        <ul class="list-group" v-if="itemsInCart && itemsInCart.length">
            <li class="list-group-item clearfix" v-for="items of itemsInCart" :key="items.id">
                <p class="float-left">{{items.productName}}</p>
                <div class="float-right clearfix">
                    <p class="float-left">Rs.{{items.price}}</p>
                    <p class="float-left">* {{items.quantity}}</p>
                </div>
            </li>
            <p style="text-align: end" class="alert alert-dark">Total Amount: Rs. {{totalAmount}}</p>
        </ul>

        <form style="margin: 40px 0" @submit.prevent="onCheckout" v-if="!orderPosted">

            <div class="form-row">

                <div class="form-group col-md-6">
                    <label for="phoneNumber">Phone Number</label>
                    <input type="tel"
                           class="form-control"
                           id="phoneNumber"
                           placeholder="Enter your phone number"
                           v-model="phoneNumber"
                           @blur="$v.phoneNumber.$touch()"
                           :class="{'is-invalid': $v.phoneNumber.$error}"/>
                    <span class="invalid-feedback">
                        <span v-if="!$v.phoneNumber.required">
                            Please enter your phone number.
                        </span>
                    </span>
                </div>

                <div class="form-group col-md-6">
                    <label for="deliveryAdd">Delivery Address</label>
                    <input type="text"
                           class="form-control"
                           id="deliveryAdd"
                           placeholder="Enter address"
                           v-model="deliveryAdd"
                           @blur="$v.deliveryAdd.$touch()"
                           :class="{'is-invalid': $v.deliveryAdd.$error}"/>
                    <span class="invalid-feedback">
                        <span v-if="!$v.deliveryAdd.required">
                            Please enter the delivery address.
                        </span>
                    </span>
                </div>
            </div>

            <button class="btn btn-primary"
                    type="submit"
                    style="width:80px"
                    :disabled="$v.$invalid">
                Confirm
            </button>
        </form>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import {required} from 'vuelidate/lib/validators';
    import ProductService from "../../services/product.service";
    import UserService from "../../services/user.service";
    import {TokenService} from "../../services/token.service";

    export default {
        data() {
            return {
                orderPosted: false,
                phoneNumber: null,
                deliveryAdd: ''
            }
        },
        validations: {
            phoneNumber: {
                required
            },
            deliveryAdd: {
                required
            }
        },
        computed: {
            ...mapGetters([
                'itemsInCart',
                'totalAmount',
                'username'
            ])
        },
        methods: {
            onCheckout() {
                const token = TokenService.getToken();
                UserService.getCurrentUser(token).subscribe(res => {
                    const formData = new FormData();
                    formData.append('user', res.data.data.id);
                    formData.append('itemsInCart', JSON.stringify(this.itemsInCart));
                    formData.append('totalAmount', this.totalAmount);
                    formData.append('phoneNumber', this.phoneNumber);
                    formData.append('deliveryAddress', this.deliveryAdd);
                    ProductService.addToCart(formData).subscribe(() => {
                        this.orderPosted = true;
                        this.$store.state.itemsInCart = [];
                    })
                })
            }
        }
    }
</script>
